; OCOPY.ASM--
; Copyright (c) 2008 Hjort Nidudsson
;
; Change history:
; 28 Oct 2008	- copyhndl(STDI, STDO, size)

INCLUDE 	clib.inc
INCLUDE		iost.inc

PPROC		ocopy		;  Copy bytes from STDI to STDO
ARG             @@cnt:	DWORD
		USES	si,edi
		mov	edi,@@cnt
		mov	si,OSTDI
		movzx	eax,[si.ios_c]
		sub	ax,[si.ios_i]
		or	edi,edi
		jz	SHORT @@ok
		cmp	eax,edi
		jae	SHORT @@flush_i
		or	ax,ax
		jz	SHORT @@flush_o
@@flush_i:	call	ogetc
		jz	SHORT @@toend
		push	ax
		call	oputc
		jz	SHORT @@toend
		dec	edi
		jz	SHORT @@ok
		mov	ax,[si.ios_i]
		cmp	ax,[si.ios_c]
		jne	SHORT @@flush_i
@@flush_o:	mov	bx,OSTDO
		xor	ax,ax
		cmp	ax,[bx.ios_i]
		je	SHORT @@copy
		call	ofwrite
		jz	SHORT @@toend
@@copy:         mov	bx,OSTDO
		push	[si.ios_bp]
		push	[si.ios_memz]
		mov	eax,[bx.ios_bp]
		mov	[si.ios_bp],eax
		mov	ax,[bx.ios_memz]
		mov	[si.ios_memz],ax
@@read:		call	ofread
		jz	SHORT @@eofread
		mov	bx,OSTDO
		movzx	eax,[si.ios_c]
		cmp	eax,edi
		jae	SHORT @@endread
		sub	edi,eax
		mov	[bx.ios_i],ax
		mov	[si.ios_i],ax
		call	ofwrite
		jnz	SHORT @@read
@@endcopy:	pop	dx
		mov	[si.ios_memz],dx
		pop	edx
		mov	[si.ios_bp],edx
		jmp	SHORT @@toend
@@ok:		xor	ax,ax
		inc	ax	; Clear ZF on return
@@toend:	ret
@@endread:      mov	bx,OSTDO
		mov	[bx.ios_i],di
		call	ofwrite
		jmp	SHORT @@endcopy
@@eofread:      xor	ax,ax
		or	edi,edi
		jnz	SHORT @@endcopy
		inc	ax
		jmp	SHORT @@endcopy
PEND		ocopy

		END
